IF OBJECT_ID('iss_Failover_Export_Generic') IS NOT NULL DROP PROCEDURE dbo.iss_Failover_Export_Generic
go
CREATE PROCEDURE dbo.iss_Failover_Export_Generic
@TableList VARCHAR(4000), --if null read table list from FailoverExportConfig table
@PrintSQL TINYINT = 0, --for dev only
@HelpFiles TINYINT = 0, --for dev only
@HelpFileDirectory VARCHAR(255) = 'C:\RSSP\Dev\Cerberus\Database\Failover', --for dev only,
@NoSelect BIT = 0 --set 1 to suppress selecting for recursive calls
AS
/* IBM Confidential - OCO Source Materials */
/* Copyright (c) IBM Corp. 2006, 2007 */
/* The source code for this program is not published or otherwise divested of its trade secrets, */
/* irrespective of what has been deposited with the U.S. Copyright Office. */ 
DECLARE @SaveErrNbr int, @SaveRowCnt int, @FirstError int, @RetVal int, @procname sysname 
SELECT @ProcName = OBJECT_NAME(@@ProcID)
SET NOCOUNT ON
-- iss_error error-number, severity, proc-name, relates-to-errorid, raise-params, errorid (OUT)
SET CONCAT_NULL_YIELDS_NULL OFF

DECLARE @IsSecondary TINYINT,
	@ExportQuery VARCHAR(8000),
	@FormatFile VARCHAR(8000),
	@Name VARCHAR(255),
	@ColOrder SMALLINT,
	@Command VARCHAR(8000),
	@CreateTable VARCHAR(8000),
	@DataType VARCHAR(20),	
	@Nullable VARCHAR(20),
	@IsPrimaryKey TINYINT,
	@BulkInsert VARCHAR(8000),
	@TableName VARCHAR(255),
	@cmd VARCHAR(7500),
	@ID INT,
	@StartLine int,
	@EndLine int,
	@LineText VARCHAR(1000),
	@ProcedureText VARCHAR(8000),
	@i int,
	@ExportFilter VARCHAR(2500),
	@UpdateSelect VARCHAR(8000),
	@DeleteSelect VARCHAR(8000),
	@InsertSelect VARCHAR(8000),
	@JoinToRecovery VARCHAR(4000),
	@JoinToBackup VARCHAR(4000),
	@DeleteFilter VARCHAR(4000),
	@UpdateFilter VARCHAR(8000),
	@InsertFilter VARCHAR(8000),
	@RefSelect VARCHAR(8000),
	@RefFilter VARCHAR(8000),
	@EOL VARCHAR(3),
	@FileDelimiter VARCHAR(3),
	@IdentityFound TINYINT,
	@IsIdentity TINYINT,
	@ConstraintName VARCHAR(255),
	@Prev_ConstraintName VARCHAR(255),
	@FK_TableName VARCHAR(255),
	@FK_ColumnName VARCHAR(255),
	@PK_ColumnName VARCHAR(255),
	@ErrMsg NVARCHAR(510),
	@RefFound TINYINT

SELECT @IsSecondary = CASE WHEN EXISTS (SELECT 1 FROM Version 
	WHERE AttributeName = 'IsSecondarySite' AND AttributeValue = 'true') THEN 1 ELSE 0 END
SELECT @EOL = CHAR(13) + CHAR(10)

CREATE TABLE #CreateProc
(ID INT IDENTITY NOT NULL,
TableName VARCHAR(255) NOT NULL,
ProcedureText VARCHAR(7500) NULL)

CREATE TABLE #CreateTable
(ID INT IDENTITY NOT NULL,
iss_Failover_Site_CreateTables VARCHAR(8000) NULL)

CREATE TABLE #BulkInsert
(ID INT IDENTITY NOT NULL,
iss_Failover_Site_LoadFiles VARCHAR(8000) NULL)

CREATE TABLE #SPList
(ID INT IDENTITY NOT NULL,
ProcName VARCHAR(255) NULL)

CREATE TABLE #FormatFile
(ID INT IDENTITY NOT NULL,
FormatFile VARCHAR(1000) NULL)

CREATE TABLE #XPUPolicy
(ID INT IDENTITY NOT NULL,
XPUPolicy VARCHAR(1000) NULL)

DECLARE c_Tables CURSOR LOCAL FOR
SELECT TABLE_NAME
FROM INFORMATION_SCHEMA.tables
WHERE (@TableList IS NOT NULL AND TABLE_NAME IN (SELECT string FROM dbo.iss_fnc_StringOfStringsToTable (@TableList,',')))
OR (@TableList IS NULL AND TABLE_NAME IN (SELECT TableName FROM FailoverExportConfig WHERE SiteMode IN (0,1)))
ORDER BY TABLE_NAME

OPEN c_Tables
FETCH NEXT FROM c_Tables INTO @TableName
WHILE @@FETCH_STATUS = 0
	BEGIN
	--set format file delimiter (special case delimiter for actiondetails table)
	SELECT @FileDelimiter = CASE WHEN @TableName = 'ActionDetails' THEN '!!~' ELSE '~!' END
	SELECT @InsertSelect = NULL, @UpdateSelect = NULL, @DeleteSelect = NULL, @UpdateFilter = NULL, 
		@DeleteFilter = NULL, @RefSelect = NULL, @RefFilter = NULL,
		@JoinToBackup = NULL, @InsertFilter = NULL,
		@Prev_ConstraintName = NULL
	--Do not export rows where FO_MergeCode = 'X'
	--These are rows imported into Secondary but not loaded due to referential constraints
	SELECT	@JoinToRecovery = 'FO_MergeCode IS NULL' + @EOL 

	SELECT @ColOrder = 0
	DECLARE c_Columns CURSOR LOCAL FOR
	SELECT co.COLUMN_NAME,
		co.DATA_TYPE + CASE WHEN DATA_TYPE = 'numeric' THEN '(' + CONVERT(VARCHAR(10),NUMERIC_PRECISION) + ',' + CONVERT(VARCHAR(10),NUMERIC_SCALE) + ')'
			WHEN DATA_TYPE NOT IN ('image','ntext','text') AND CHARACTER_MAXIMUM_LENGTH > 0 THEN '(' + CONVERT(VARCHAR(10),CHARACTER_MAXIMUM_LENGTH) + ')'
			ELSE '' END,
		co.IS_NULLABLE,
		CASE WHEN pk.CONSTRAINT_TYPE = 'PRIMARY KEY' THEN 1 ELSE 0 END IS_PRIMARYKEY
	FROM INFORMATION_SCHEMA.columns co
		LEFT OUTER JOIN (INFORMATION_SCHEMA.TABLE_CONSTRAINTS pk 
			INNER JOIN INFORMATION_SCHEMA.KEY_COLUMN_USAGE c
			ON pk.TABLE_NAME = c.TABLE_NAME
			AND pk.CONSTRAINT_NAME = c.CONSTRAINT_NAME
			AND pk.CONSTRAINT_TYPE = 'PRIMARY KEY')
		ON co.TABLE_NAME = c.TABLE_NAME
		AND co.COLUMN_NAME = c.COLUMN_NAME
	WHERE co.TABLE_NAME = @TableName
	ORDER BY co.COLUMN_NAME

	OPEN c_Columns
	FETCH NEXT FROM c_Columns INTO @Name, @DataType, @Nullable, @IsPrimaryKey
	SELECT @ExportQuery = 'SELECT ' 

	INSERT INTO #FormatFile(FormatFile)
	VALUES('7.0')
	INSERT INTO #FormatFile(FormatFile)
	VALUES('#NumCols#')

	SELECT @CreateTable = ISNULL(@CreateTable,'') + @EOL + 'IF OBJECT_ID(' + '''' + @TableName + '_Recovery' + '''' + ') IS NOT NULL DROP TABLE dbo.' + @TableName + '_Recovery' + @EOL +
	CASE WHEN @TableName NOT IN ('Component','NetworkInterface') THEN 'IF @IsPrimaryExport = 0' + @EOL ELSE '' END + 
	'CREATE TABLE dbo.' + @TableName + '_Recovery' + '(' + @EOL
	SELECT @BulkInsert = ISNULL(@BulkInsert,'') + @EOL + '
IF EXISTS (SELECT 1 FROM FailoverExportConfig WHERE TableName = ' + '''' + @TableName + '''' 
	+ ' AND (SiteMode = 0 OR (@IsSecondary = 1 AND SiteMode = 1)))
	BEGIN
	EXEC @RetVal = iss_Failover_BulkInsert @FailOverDirectory = @FailOverDirectory, @TableName = ' + '''' + @TableName + '''' + ' 
	IF @RetVal <> 0 OR @@ERROR <> 0
		BEGIN	
		EXEC iss_error 55001, 4, @ProcName, NULL, ' + '''' + 'iss_Failover_BulkInsert:' + @TableName + '''' + ', NULL
		RETURN(1)
		END
	END'
	
	WHILE @@FETCH_STATUS = 0
		BEGIN
		SELECT @ColOrder = @ColOrder + 1
		SELECT @ExportQuery = @ExportQuery + CASE WHEN @ColOrder = 1 THEN '' ELSE ',' END + @TableName + '.' + @Name
		SELECT @FormatFile = CONVERT(VARCHAR(10),@ColOrder) + CHAR(9) + 'SQLCHAR' + CHAR(9) + '0	0	"' + @FileDelimiter + '"		' + CONVERT(VARCHAR(10),@ColOrder) + CHAR(9) + @Name  

		INSERT INTO #FormatFile(FormatFile)
		SELECT @FormatFile

		SELECT @CreateTable = @CreateTable + CHAR(9) + CASE WHEN @ColOrder = 1 THEN '' ELSE ',' END + @Name + '	' + @DataType + '	' 
			+ CASE WHEN @Nullable = 'YES' THEN 'NULL' ELSE 'NOT NULL' END + @EOL
		IF @IsPrimaryKey = 0 AND @DataType NOT IN ('text','ntext','image') AND @Name NOT IN ('LastModifiedAt')
			SELECT @UpdateFilter = ISNULL(@UpdateFilter,'') + CASE WHEN @UpdateFilter IS NULL THEN '' ELSE ',' END + @TableName + '.' + @Name 

		SELECT @FormatFile = ''
		FETCH NEXT FROM c_Columns INTO @Name, @DataType, @Nullable, @IsPrimaryKey
		END
	CLOSE c_Columns
	DEALLOCATE c_Columns

	--If no non-primary key columns exist, don't search for changed records
	IF @UpdateFilter IS NULL
		SELECT @UpdateFilter = 'WHERE 1 = 2'
	ELSE
		SELECT @UpdateFilter = 'WHERE BINARY_CHECKSUM(' + @UpdateFilter + ') <> BINARY_CHECKSUM(' +
			REPLACE(@UpdateFilter, @TableName+'.', @TableName + '_Recovery.') + ')'
 
	--Add any primary key columns to table with prefix = "FO_"
	DECLARE c_Pk CURSOR LOCAL FOR
	SELECT 	co.COLUMN_NAME,
		co.DATA_TYPE + CASE WHEN co.DATA_TYPE = 'numeric' THEN '(' + CONVERT(VARCHAR(10),NUMERIC_PRECISION) + ',' + CONVERT(VARCHAR(10),NUMERIC_SCALE) + ')'
		WHEN CHARACTER_MAXIMUM_LENGTH > 0 THEN '(' + CONVERT(VARCHAR(10),CHARACTER_MAXIMUM_LENGTH) + ')'
		ELSE '' END,
		COLUMNPROPERTY(OBJECT_ID(pk.TABLE_NAME),co.COLUMN_NAME,'IsIdentity') IsIdentity
	FROM 	INFORMATION_SCHEMA.TABLE_CONSTRAINTS pk 
		INNER JOIN INFORMATION_SCHEMA.KEY_COLUMN_USAGE c
		ON pk.TABLE_NAME = c.TABLE_NAME
		AND pk.CONSTRAINT_NAME = c.CONSTRAINT_NAME
		INNER JOIN INFORMATION_SCHEMA.COLUMNS co
		ON c.TABLE_NAME = co.TABLE_NAME
		AND c.COLUMN_NAME = co.COLUMN_NAME
	WHERE 	pk.TABLE_NAME = @TableName
	AND	pk.CONSTRAINT_TYPE = 'PRIMARY KEY'
	ORDER BY COLUMNPROPERTY(OBJECT_ID(pk.TABLE_NAME),co.COLUMN_NAME,'IsIdentity') DESC,
		co.COLUMN_NAME

	OPEN c_Pk
	FETCH NEXT FROM c_Pk INTO @Name, @DataType, @IsIdentity
	SELECT @UpdateSelect = @ExportQuery 
	SELECT @RefSelect = @ExportQuery
	SELECT @DeleteSelect = REPLACE(@ExportQuery,@TableName+'.',@TableName+'_Recovery.') 
	SELECT @IdentityFound = 0
	WHILE @@FETCH_STATUS = 0 AND @IdentityFound = 0	
		BEGIN
		IF @IsIdentity = 1
			BEGIN
			SELECT @CreateTable = @CreateTable + CHAR(9) + ',FO_' + @Name + '	' + @DataType + '	NULL' + @EOL

			SELECT @ColOrder = @ColOrder + 1
			SELECT @FormatFile = CONVERT(VARCHAR(10),@ColOrder) + CHAR(9) + 'SQLCHAR' + CHAR(9) + '0	0	"' + @FileDelimiter + '"		' + CONVERT(VARCHAR(10),@ColOrder) + CHAR(9) + 'FO_' + @Name  
			INSERT INTO #FormatFile(FormatFile)
			SELECT @FormatFile

			SELECT @ExportQuery = @ExportQuery + ',NULL AS FO_' + @Name 
			SELECT @UpdateSelect = @UpdateSelect + ',' + @TableName + '_Recovery.' + @Name + ' AS FO_' + @Name
			SELECT @RefSelect = @RefSelect + ',' + @TableName + '_Recovery.' + @Name + ' AS FO_' + @Name
			SELECT @DeleteSelect = REPLACE(@DeleteSelect,@TableName + '_Recovery.' + @Name,@TableName + '_Recovery.FO_' + @Name) + ',' + @TableName + '_Recovery.' + @Name  
			END

		SELECT @DeleteFilter = ISNULL(@DeleteFilter,'') + CASE WHEN @DeleteFilter IS NOT NULL THEN 'AND ' ELSE '' END + @TableName + '_Recovery.' + CASE WHEN @IsIdentity = 1 THEN 'FO_' ELSE '' END + @Name + ' IS NOT NULL' + @EOL
		SELECT @JoinToRecovery = ISNULL(@JoinToRecovery,'') + CASE WHEN @JoinToRecovery IS NOT NULL THEN 'AND ' ELSE '' END + @TableName + '.' + @Name + ' = ' + @TableName + '_Recovery.' + CASE WHEN @IsIdentity = 1 THEN 'FO_' ELSE '' END + @Name + @EOL
		SELECT @JoinToBackup = ISNULL(@JoinToBackup,'') + CASE WHEN @JoinToBackup IS NOT NULL THEN 'AND ' ELSE '' END + @TableName + '.' + @Name + ' = ' + @TableName + '_Backup.' + @Name + @EOL
		SELECT @RefFilter = CASE WHEN @RefFilter IS NULL 
			THEN 'WHERE NOT EXISTS (SELECT 1 FROM ' + @TableName + '_Exported' + @EOL + 'WHERE ' + @TableName + '_Exported.' + @Name + ' = ' + @TableName + '.' + @Name 
			ELSE ISNULL(@RefFilter,'') + @EOL + 'AND ' + @TableName + '_Exported.' + @Name + ' = ' + @TableName + '.' + @Name END
		SELECT @IdentityFound = @IsIdentity
		FETCH NEXT FROM c_Pk INTO @Name, @DataType, @IsIdentity
		END
	CLOSE c_Pk
	DEALLOCATE c_Pk

	--Add FO_MergeCode column to identify update/inserted/deleted rows on failover from secondary to primary
	SELECT @CreateTable = @CreateTable + CHAR(9) + ',FO_MergeCode	CHAR(1)	NULL' + @EOL
	SELECT @InsertSelect = @ExportQuery + ',' + '''' + 'I' + '''' + ' AS FO_MergeCode'  
	SELECT @UpdateSelect = @UpdateSelect + ',' + '''' + 'U' + '''' + ' AS FO_MergeCode'  
	SELECT @DeleteSelect = @DeleteSelect + ',' + '''' + 'D' + '''' + ' AS FO_MergeCode'  
	SELECT @RefSelect = @RefSelect + ',' + '''' + 'R' + '''' + ' AS FO_MergeCode' 
	SELECT @ExportQuery = @ExportQuery + ',NULL AS FO_MergeCode'  
	SELECT @RefFilter = CASE WHEN @RefFilter IS NULL THEN 'WHERE 1 = 2' + @EOL ELSE @RefFilter + ')' + @EOL END

	--Add last line delimter with end or row delimiter
	SELECT @ColOrder = @ColOrder + 1
	SELECT @FormatFile = CONVERT(VARCHAR(10),@ColOrder) + CHAR(9) + 'SQLCHAR' + CHAR(9) + '0	0	"~eor\r\n"		' + CONVERT(VARCHAR(10),@ColOrder) + CHAR(9) + 'FO_MergeCode'  

	INSERT INTO #FormatFile(FormatFile)
	SELECT @FormatFile

	--Set total columns in format file
	UPDATE #FormatFile
	SET FormatFile = REPLACE(FormatFile,'#NumCols#',CONVERT(VARCHAR(10),@ColOrder))
	WHERE ID = 2


	--End create table statement and add error handling
	SELECT @CreateTable = @CreateTable + CHAR(9) + ')	
-- standard SQL statement error handling
SELECT	@SaveErrNbr = @@ERROR, 	@SaveRowCnt = @@ROWCOUNT
IF @SaveErrNbr <> 0	
	BEGIN
	IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION
	EXEC iss_error @SaveErrNbr, null, @ProcName, null, null, @FirstError OUTPUT
	EXEC iss_error 55000, 4, @ProcName, @FirstError, ' + '''' + @TableName + '_Recovery' + '''' + ', null
	RETURN(1)
	END
'
	--Create Insert filter
	--Only export new records from secondary if the record is referenced by other records
	--This helps reduce size of export from large tables, like NetworkInterface

	DECLARE c_FK CURSOR LOCAL FOR
	SELECT fkc.CONSTRAINT_NAME, fkc.TABLE_NAME, fkc.COLUMN_NAME fkcol, pkc.COLUMN_NAME as pkcol
	FROM INFORMATION_SCHEMA.REFERENTIAL_CONSTRAINTS rc
		INNER JOIN INFORMATION_SCHEMA.TABLE_CONSTRAINTS pk
		ON rc.UNIQUE_CONSTRAINT_NAME = pk.CONSTRAINT_NAME
		INNER JOIN INFORMATION_SCHEMA.TABLE_CONSTRAINTS fk
		ON rc.CONSTRAINT_NAME = fk.CONSTRAINT_NAME
		INNER JOIN INFORMATION_SCHEMA.KEY_COLUMN_USAGE fkc
		ON fk.CONSTRAINT_NAME = fkc.CONSTRAINT_NAME
		INNER JOIN INFORMATION_SCHEMA.KEY_COLUMN_USAGE pkc
		ON pk.CONSTRAINT_NAME = pkc.CONSTRAINT_NAME
	WHERE	pk.TABLE_NAME = @TableName
	AND	pk.CONSTRAINT_TYPE = 'PRIMARY KEY'
	AND	fk.TABLE_NAME IN (SELECT TableName FROM FailoverExportConfig WHERE SiteMode = 0)
	ORDER BY fkc.CONSTRAINT_NAME, fkc.TABLE_NAME

	OPEN c_FK
	FETCH NEXT FROM c_FK INTO @ConstraintName, @FK_TableName, @FK_ColumnName, @PK_ColumnName

	WHILE @@FETCH_STATUS = 0
		BEGIN
		IF @TableList IS NOT NULL AND @IsSecondary = 1
			BEGIN
			IF @NoSelect = 0
				BEGIN
				IF OBJECT_ID('tempdb..#ExportConstraints') IS NOT NULL
					DROP TABLE #ExportConstraints
				CREATE TABLE #ExportConstraints (ConstraintName	SYSNAME)
				END
			IF NOT EXISTS (SELECT 1 FROM #ExportConstraints WHERE ConstraintName = @ConstraintName)
				BEGIN
				INSERT #ExportConstraints (ConstraintName)
				SELECT @ConstraintName
				-- Make a recursive call to self to ensure that we export referenced records from foreign tables
				PRINT 'Nest level, ' + CAST(@@NESTLEVEL AS VARCHAR(2)) + ', recurse from ' + @TableList + ' to ' + @FK_TableName
				EXEC iss_Failover_Export_Generic @FK_TableName, @PrintSQL, 0, null, 1 
			END
		END		
		IF @TableName = 'NetworkInterface'
		BEGIN
			SELECT @InsertFilter = ISNULL(@InsertFilter,'') + CASE WHEN @InsertFilter IS NULL THEN 'AND (' ELSE '' END +
				CASE WHEN @Prev_ConstraintName IS NULL THEN '' ELSE ')' + @EOL + 'OR ' END +
				CASE WHEN @ConstraintName <> ISNULL(@Prev_ConstraintName,'') 
				THEN 'EXISTS (SELECT 1 FROM ' + @FK_TableName + @EOL + 'WHERE ' ELSE @EOL + 'AND ' END + 
				@FK_TableName + '.' + @FK_ColumnName + ' = ' + @TableName + '.' + @PK_ColumnName
		END
		IF @TableName = 'Principal'
			BEGIN
			IF @Prev_ConstraintName IS NULL 
				SELECT @RefFilter = ISNULL(@RefFilter,'') + 'AND ((1=1'
			END
		ELSE
			BEGIN
			SELECT @RefFilter = ISNULL(@RefFilter,'') + 
				CASE WHEN @Prev_ConstraintName IS NULL THEN 'AND (' ELSE ')' + @EOL + 'OR ' END +
				CASE WHEN @ConstraintName <> ISNULL(@Prev_ConstraintName,'') 
				THEN 'EXISTS (SELECT 1 FROM ' + @FK_TableName + '_Exported' + @EOL + 'WHERE ' 
				ELSE @EOL + 'AND ' END + 
				@FK_TableName + '_Exported.' + @FK_ColumnName + ' = ' + @TableName + '.' + @PK_ColumnName
			END
		SELECT @Prev_ConstraintName = @ConstraintName

		FETCH NEXT FROM c_FK INTO @ConstraintName, @FK_TableName, @FK_ColumnName, @PK_ColumnName
		END
	CLOSE c_FK
	DEALLOCATE c_FK
	SELECT @InsertFilter = CASE WHEN @InsertFilter IS NULL THEN '' ELSE @InsertFilter + '))' END
	SELECT @RefFilter = @RefFilter + '))' 
	SELECT @RefFound = CASE WHEN @ConstraintName IS NULL THEN 0 ELSE 1 END

	--Build export query
	IF @HelpFiles = 0
		BEGIN
		IF @IsSecondary = 0
			BEGIN
			SELECT @ExportFilter = CASE WHEN ExportFilter IS NULL THEN '' ELSE @EOL + 'WHERE ' + ExportFilter END
			FROM FailoverExportConfig WHERE TableName = @TableName

			IF @PrintSQL = 1
				SELECT @ExportQuery + @EOL + 'FROM ' + @TableName + @ExportFilter

			EXEC (@ExportQuery + @EOL + 'FROM ' + @TableName + @ExportFilter)

			-- Trap SQL Error
			SELECT	@SaveErrNbr = @@ERROR, @SaveRowCnt = @@ROWCOUNT
			IF @SaveErrNbr <> 0	
				BEGIN
				IF @@TRANCOUNT > 0 ROLLBACK TRAN
				EXEC iss_error @SaveErrNbr, null, @ProcName, null, null, @FirstError OUTPUT
				EXEC iss_error 51000, 4, @ProcName, @FirstError, @TableName, null
				RETURN(1)
				END
			END
		ELSE
			BEGIN
			IF NOT EXISTS (SELECT 1 FROM sysobjects WHERE OBJECT_NAME(id) = (@TableName + '_Exported'))
				BEGIN
				DECLARE @RecoveryName VARCHAR(255)
				SET @RecoveryName = @TableName + '_Recovery'
				IF OBJECT_ID(@RecoveryName) IS NULL
					BEGIN
					RAISERROR('This secondary Site has not performed an import of primary Site configuration data. You can not export secondary Site policy or event data until you have done so.', 16, 1)
					RETURN(1)
					END
				--Create exported table 
				EXEC('SELECT * INTO dbo.' + @TableName + '_Exported ' + @EOL +
					'FROM dbo.' + @TableName + '_Recovery' + @EOL +
					'WHERE 1=2')
	
				-- Trap SQL Error
				SELECT	@SaveErrNbr = @@ERROR, @SaveRowCnt = @@ROWCOUNT
				SELECT @ErrMsg = @TableName + '_Recovery'
				IF @SaveErrNbr <> 0	
					BEGIN
					IF @@TRANCOUNT > 0 ROLLBACK TRAN
					EXEC iss_error @SaveErrNbr, null, @ProcName, null, null, @FirstError OUTPUT
					EXEC iss_error 51000, 4, @ProcName, @FirstError, @ErrMsg, null
					RETURN(1)
					END

				IF @PrintSQL = 1
				SELECT 'INSERT dbo.' + @TableName + '_Exported' + @EOL +
					@InsertSelect + @EOL +  
					'FROM '	+ @TableName + @EOL + 				
					'WHERE NOT EXISTS (SELECT 1 FROM ' + @TableName + '_Recovery' + @EOL +
					'	WHERE ' + @JoinToRecovery + ')' + @EOL + 
					'AND NOT EXISTS (SELECT 1 FROM ' + @TableName + '_Backup' + @EOL +
					'	WHERE ' + @JoinToBackup + ')' + @EOL + 
					@InsertFilter + @EOL +
					'UNION ALL' + @EOL + 
					@DeleteSelect + @EOL + 
					'FROM ' + @TableName + '_Recovery' + @EOL + 
					'WHERE NOT EXISTS (SELECT 1 FROM ' + @TableName + @EOL +	
					'	WHERE ' + @JoinToRecovery + ')' + @EOL + 
					'AND FO_MergeCode IS NULL ' + @EOL + 
					'AND ' + @DeleteFilter + @EOL +
					'UNION ALL' + @EOL + 
					@UpdateSelect + @EOL + 
					'FROM ' + @TableName + @EOL + 
					'INNER JOIN ' + @TableName + '_Recovery' + @EOL + 
					'ON ' + @JoinToRecovery + @EOL + 
					@UpdateFilter 
	
				EXEC('INSERT dbo.' + @TableName + '_Exported' + @EOL +
					@InsertSelect + @EOL +  
					'FROM '	+ @TableName + @EOL + 				
					'WHERE NOT EXISTS (SELECT 1 FROM ' + @TableName + '_Recovery' + @EOL +
					'	WHERE ' + @JoinToRecovery + ')' + @EOL + 
					'AND NOT EXISTS (SELECT 1 FROM ' + @TableName + '_Backup' + @EOL +
					'	WHERE ' + @JoinToBackup + ')' + @EOL + 
					@InsertFilter + @EOL +
					'UNION ALL' + @EOL + 
					@DeleteSelect + @EOL + 
					'FROM ' + @TableName + '_Recovery' + @EOL + 
					'WHERE NOT EXISTS (SELECT 1 FROM ' + @TableName + @EOL +	
					'	WHERE ' + @JoinToRecovery + ')' + @EOL + 
					'AND FO_MergeCode IS NULL ' + @EOL + 
					'AND ' + @DeleteFilter + @EOL +
					'UNION ALL' + @EOL + 
					@UpdateSelect + @EOL + 
					'FROM ' + @TableName + @EOL + 
					'INNER JOIN ' + @TableName + '_Recovery' + @EOL + 
					'ON ' + @JoinToRecovery + @EOL + 
					@UpdateFilter)
	
				-- Trap SQL Error
				SELECT	@SaveErrNbr = @@ERROR, @SaveRowCnt = @@ROWCOUNT
				IF @SaveErrNbr <> 0	
					BEGIN
					IF @@TRANCOUNT > 0 ROLLBACK TRAN
					EXEC iss_error @SaveErrNbr, null, @ProcName, null, null, @FirstError OUTPUT
					EXEC iss_error 51000, 4, @ProcName, @FirstError, @TableName, null
					RETURN(1)
					END
				END	
			IF @TableList IS NOT NULL AND @RefFound = 1
				BEGIN
				IF @PrintSQL = 1
				SELECT 'INSERT INTO dbo.' + @TableName + '_Exported' + @EOL +
				@RefSelect + @EOL + 
				'FROM ' + @TableName + @EOL + 
				'INNER JOIN ' + @TableName + '_Recovery' + @EOL + 
				'ON ' + @JoinToRecovery + @EOL + 
				@RefFilter

				EXEC('INSERT INTO dbo.' + @TableName + '_Exported' + @EOL +
				@RefSelect + @EOL + 
				'FROM ' + @TableName + @EOL + 
				'INNER JOIN ' + @TableName + '_Recovery' + @EOL + 
				'ON ' + @JoinToRecovery + @EOL + 
				@RefFilter)

				-- Trap SQL Error
				SELECT	@SaveErrNbr = @@ERROR, @SaveRowCnt = @@ROWCOUNT
				SELECT @ErrMsg = @TableName + '_Exported'
				IF @SaveErrNbr <> 0	
					BEGIN
					IF @@TRANCOUNT > 0 ROLLBACK TRAN
					EXEC iss_error @SaveErrNbr, null, @ProcName, null, null, @FirstError OUTPUT
					EXEC iss_error 52000, 4, @ProcName, @FirstError, @ErrMsg, null
					RETURN(1)
					END
				END
			IF @TableList IS NOT NULL
				BEGIN
				--Return results
				IF @NoSelect = 0
					EXEC('SELECT * FROM dbo.' + @TableName + '_Exported')

				-- Trap SQL Error
				SELECT	@SaveErrNbr = @@ERROR, @SaveRowCnt = @@ROWCOUNT
				SELECT @ErrMsg = @TableName + '_Exported'
				IF @SaveErrNbr <> 0	
					BEGIN
					IF @@TRANCOUNT > 0 ROLLBACK TRAN
					EXEC iss_error @SaveErrNbr, null, @ProcName, null, null, @FirstError OUTPUT
					EXEC iss_error 51000, 4, @ProcName, @FirstError, @ErrMsg, null
					RETURN(1)
					END
				END
			END
		END
	ELSE
		BEGIN
		--Write format file
		DECLARE c_FormatFile CURSOR LOCAL FOR
		SELECT ID, FormatFile
		FROM #FormatFile
		ORDER BY ID

		OPEN c_FormatFile
		FETCH NEXT FROM c_FormatFile INTO @ID, @FormatFile
		WHILE @@FETCH_STATUS = 0
			BEGIN
			IF @ID = 1
				SELECT @cmd = 'echo.' + @FormatFile + ' > "' + @HelpFileDirectory + '\' + @TableName + '.fmt"'
			ELSE
				SELECT @cmd = 'echo.' + @FormatFile + ' >> "' + @HelpFileDirectory + '\' + @TableName + '.fmt"'

			EXEC master..xp_cmdshell @cmd, no_output
			FETCH NEXT FROM c_FormatFile INTO @ID, @FormatFile
			END
--select @tablename, id, formatfile from #formatfile
		CLOSE c_FormatFile
		DEALLOCATE c_FormatFile
		TRUNCATE TABLE #FormatFile

		--Write export procedure
		SELECT @cmd = REPLACE(REPLACE( 
'IF OBJECT_ID(''iss_Failover_Export_#TableName#'') IS NOT NULL DROP PROCEDURE dbo.iss_Failover_Export_#TableName#
#GO#
CREATE PROCEDURE dbo.iss_Failover_Export_#TableName#
AS
/* IBM Confidential - OCO Source Materials */
/* Copyright (c) IBM Corp. 2006, 2007 */
/* The source code for this program is not published or otherwise divested of its trade secrets, */
/* irrespective of what has been deposited with the U.S. Copyright Office. */ 
DECLARE @SaveErrNbr int, @SaveRowCnt int, @FirstError int, @RetVal int, @ProcName sysname 
SELECT @ProcName = OBJECT_NAME(@@ProcID)
SET NOCOUNT ON
-- iss_error error-number, severity, proc-name, relates-to-errorid, raise-params, errorid (OUT)

EXEC @RetVal = iss_Failover_Export_Generic ''#TableName#''
IF @RetVal <> 0 OR @@ERROR <> 0
	BEGIN
	IF @@TRANCOUNT > 0 ROLLBACK TRAN
	EXEC iss_error @SaveErrNbr, null, @ProcName, null, null, @FirstError OUTPUT
	EXEC iss_error 55001, 4, @ProcName, @FirstError, ''iss_Failover_Export_Generic'', null
	RETURN(1)
	END

RETURN (0)
#GO#
','#TableName#',@TableName),'#GO#','GO') 

		--Write procedure to temp table - later write to file
		INSERT INTO #CreateProc(TableName,ProcedureText)
		VALUES(@TableName, @cmd)
		
		--Write SPList.txt
		INSERT INTO #SPList(ProcName)
		SELECT 'iss_Failover_Export_' + @TableName

		--Write create tables 
		INSERT INTO #CreateTable(iss_Failover_Site_CreateTables)
		SELECT @CreateTable  

		SELECT @CreateTable = ''

		--Write bulk insert 
		INSERT INTO #BulkInsert(iss_Failover_Site_LoadFiles)
		SELECT @BulkInsert  

		SELECT @BulkInsert = ''
		END
	INSERT INTO #XPUPolicy
	SELECT '
[\ISS Update\Updates\Update21\];
Action	=S	sqlScript;
FileName	=S	iss_Failover_Export_' + @TableName + '.sql;
LogEntry	=S	---Executing script iss_Failover_Export_' + @TableName + '.sql---;
ExecAfterErr	=B	0;
'

	FETCH NEXT FROM c_Tables INTO @TableName
	END

IF @HelpFiles = 1
	BEGIN
	DECLARE c_Procedure CURSOR FOR
	SELECT TableName, ProcedureText 
	FROM	#CreateProc

	OPEN c_Procedure
	FETCH NEXT FROM c_Procedure INTO @TableName, @ProcedureText

	WHILE @@FETCH_STATUS = 0
		BEGIN
		SELECT @StartLine = 1, @EndLine = 1, @i = 1
		WHILE @EndLine > 0
			BEGIN
			SELECT @EndLine = CHARINDEX(CHAR(13),@ProcedureText,@StartLine)	
			IF @EndLine > 0 
				SELECT @LineText = SUBSTRING(@ProcedureText,@StartLine,@EndLine-@StartLine)
			ELSE
				SELECT @LineText = SUBSTRING(@ProcedureText,@StartLine,LEN(@ProcedureText))

			SELECT @LineText = REPLACE(@LineText, '^', '^^')
			SELECT @LineText = REPLACE(@LineText, '|', '^|')		
			SELECT @LineText = REPLACE(@LineText, '<', '^<')
			SELECT @LineText = REPLACE(@LineText, '>', '^>')
		
			IF @i = 1
				SELECT @cmd = 'echo.' + @LineText + ' > "' + @HelpFileDirectory + '\iss_Failover_Export_' + @TableName + '.sql"'
			ELSE 
				SELECT @cmd = 'echo.' + @LineText + ' >> "' + @HelpFileDirectory + '\iss_Failover_Export_' + @TableName + '.sql"'
	
--			SELECT @StartLine, @EndLine, @LineText
			EXEC master..xp_cmdshell @cmd, no_output
		
			SELECT @StartLine = @EndLine + 2
			SELECT @i = @i+1
			END

		FETCH NEXT FROM c_Procedure INTO @TableName, @ProcedureText
		END
	CLOSE c_Procedure
	DEALLOCATE c_Procedure	 

	SELECT iss_Failover_Site_CreateTables 
	FROM #CreateTable 

	SELECT iss_Failover_Site_LoadFiles 
	FROM #BulkInsert 

	SELECT ProcName as AllExportProcedures
	FROM #SPList
	UNION
	SELECT ProcedureName 
	FROM FailoverExportConfig

	SELECT CONVERT(VARCHAR(12),ConfigType) + @FileDelimiter 
	+ TableName + @FileDelimiter + 
	+ ProcedureName + @FileDelimiter + 
	+ Parameters + @FileDelimiter + 
	+ CONVERT(VARCHAR(12),SiteMode) + @FileDelimiter + 
	+ ExportFilter + '~eor' AS 'Exported using following FailoverExportConfig'
	from
	failoverexportconfig
	
	SELECT XPUPolicy
	FROM #XPUPolicy

	PRINT ''
	PRINT 'The format file and export stored procedure for each table has been saved '
	PRINT 'to the following directory on the database server:' 
	PRINT @HelpFileDirectory

	END
GO
