IF OBJECT_ID('iss_Failover_Import') IS NOT NULL DROP PROCEDURE dbo.iss_Failover_Import
go
CREATE PROCEDURE dbo.iss_Failover_Import
	@FailOverDirectory varchar(255)
AS
/* IBM Confidential - OCO Source Materials */
/* Copyright (c) IBM Corp. 1992, 2007 */
/* Copyright (c) Internet Security Systems, Inc. 1992-2006 */
/* The source code for this program is not published or otherwise divested of its trade secrets, */
/* irrespective of what has been deposited with the U.S. Copyright Office. */ 
DECLARE @SaveErrNbr int, @SaveRowCnt int, @FirstError int, @RetVal int, @ProcName sysname 
SELECT @ProcName = OBJECT_NAME(@@ProcID)
SET NOCOUNT ON
-- iss_error error-number, severity, proc-name, relates-to-errorid, raise-params, errorid (OUT)

EXEC @RetVal = iss_Failover_Import_Special_Pre
IF @RetVal <> 0 OR @@ERROR <> 0
	BEGIN	
	EXEC iss_error 55001, 4, @ProcName, NULL, 'iss_Failover_Import_Special_Pre', NULL
	RETURN(1)
	END

EXEC @RetVal = iss_Failover_Import_Updates
IF @RetVal <> 0 OR @@ERROR <> 0
	BEGIN	
	EXEC iss_error 55001, 4, @ProcName, NULL, 'iss_Failover_Import_Updates', NULL
	RETURN(1)
	END

EXEC @RetVal = iss_Failover_Import_Special_Post
IF @RetVal <> 0 OR @@ERROR <> 0
	BEGIN	
	EXEC iss_error 55001, 4, @ProcName, NULL, 'iss_Failover_Import_Special_Post', NULL
	RETURN(1)
	END

EXEC @RetVal = iss_Failover_Site_DropTriggers
IF @RetVal <> 0 OR @@ERROR <> 0
	BEGIN	
	EXEC iss_error 55001, 4, @ProcName, NULL, 'iss_Failover_Site_DropTriggers', NULL
	RETURN(1)
	END

EXEC @RetVal = iss_Failover_Import_Inserts
IF @RetVal <> 0 OR @@ERROR <> 0
	BEGIN	
	EXEC iss_error 55001, 4, @ProcName, NULL, 'iss_Failover_Import_Inserts', NULL
	RETURN(1)
	END

EXEC @RetVal = iss_Failover_Import_Final
IF @RetVal <> 0 OR @@ERROR <> 0
	BEGIN	
	EXEC iss_error 55001, 4, @ProcName, NULL, 'iss_Failover_Import_Final', NULL
	RETURN(1)
	END

RETURN(0)
GO